Index: src/tesselation.cpp
===================================================================
--- src/tesselation.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/tesselation.cpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
@@ -3509,13 +3726,13 @@
   BTS->GetNormalVector(TempTriangle->NormalVector);
   BTS->NormalVector.Scale(-1.);
-  Log() << Verbose(3) << "INFO: NormalVector of new triangle is " << BTS->NormalVector << "." << endl;
+  Log() << Verbose(1) << "INFO: NormalVector of new triangle is " << BTS->NormalVector << "." << endl;
   AddTesselationTriangle();
 
   // create other side of this triangle and close both new sides of the first created triangle
-  Log() << Verbose(5) << "Adding new triangle points."<< endl;
+  Log() << Verbose(2) << "Adding new triangle points."<< endl;
   AddTesselationPoint((BestLine->endpoints[0]->node), 0);
   AddTesselationPoint((BestLine->endpoints[1]->node), 1);
   AddTesselationPoint(point, 2);
-  Log() << Verbose(5) << "Adding new triangle lines."<< endl;
+  Log() << Verbose(2) << "Adding new triangle lines."<< endl;
   AddTesselationLine(TPS[0], TPS[1], 0);
   AddTesselationLine(TPS[0], TPS[2], 1);
@@ -3523,5 +3740,5 @@
   BTS = new class BoundaryTriangleSet(BLS, TrianglesOnBoundaryCount);
   BTS->GetNormalVector(TempTriangle->NormalVector);
-  Log() << Verbose(3) << "INFO: NormalVector of other new triangle is " << BTS->NormalVector << "." << endl;
+  Log() << Verbose(1) << "INFO: NormalVector of other new triangle is " << BTS->NormalVector << "." << endl;
   AddTesselationTriangle();
 
@@ -3530,6 +3747,6 @@
     if ((BTS->lines[i]->ContainsBoundaryPoint(BestLine->endpoints[0])) && (BTS->lines[i]->ContainsBoundaryPoint(BestLine->endpoints[1]))) {
       if (BestLine == BTS->lines[i]){
-        Log() << Verbose(1) << "CRITICAL: BestLine is same as found line, something's wrong here!" << endl;
-        exit(255);
+        eLog() << Verbose(0) << "BestLine is same as found line, something's wrong here!" << endl;
+        performCriticalExit();
       }
       BTS->lines[i]->triangles.insert( pair<int, class BoundaryTriangleSet *> (TempTriangle->Nr, TempTriangle) );
@@ -3538,7 +3755,4 @@
     }
   }
-
-  // exit
-  Log() << Verbose(2) << "End of AddBoundaryPointByDegeneratedTriangle" << endl;
 };
 
@@ -3550,4 +3764,5 @@
 void Tesselation::Output(const char *filename, const PointCloud * const cloud)
 {
+	Info FunctionInfo(__func__);
   ofstream *tempstream = NULL;
   string NameofTempFile;
@@ -3562,5 +3777,5 @@
       NameofTempFile.erase(npos, 1);
       NameofTempFile.append(TecplotSuffix);
-      Log() << Verbose(1) << "Writing temporary non convex hull to file " << NameofTempFile << ".\n";
+      Log() << Verbose(0) << "Writing temporary non convex hull to file " << NameofTempFile << ".\n";
       tempstream = new ofstream(NameofTempFile.c_str(), ios::trunc);
       WriteTecplotFile(tempstream, this, cloud, TriangleFilesWritten);
@@ -3576,5 +3791,5 @@
       NameofTempFile.erase(npos, 1);
       NameofTempFile.append(Raster3DSuffix);
-      Log() << Verbose(1) << "Writing temporary non convex hull to file " << NameofTempFile << ".\n";
+      Log() << Verbose(0) << "Writing temporary non convex hull to file " << NameofTempFile << ".\n";
       tempstream = new ofstream(NameofTempFile.c_str(), ios::trunc);
       WriteRaster3dFile(tempstream, this, cloud);
Index: src/tesselation.hpp
===================================================================
--- src/tesselation.hpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/tesselation.hpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
@@ -53,4 +53,5 @@
 #define PointTestPair pair < PointMap::iterator, bool >
 #define CandidateList list <class CandidateForTesselation *>
+#define CandidateMap map <class BoundaryLineSet *, class CandidateForTesselation *>
 
 #define LineMap multimap < int, class BoundaryLineSet * >
@@ -64,4 +65,6 @@
 #define DistanceMultiMap multimap <double, pair < PointMap::iterator, PointMap::iterator> >
 #define DistanceMultiMapPair pair <double, pair < PointMap::iterator, PointMap::iterator> >
+
+#define TesselPointList list <TesselPoint *>
 
 /********************************************** declarations *******************************/
@@ -114,4 +117,5 @@
     TriangleMap triangles;
     int Nr;
+    bool skipped;
 };
 
@@ -170,4 +174,5 @@
   virtual ~PointCloud();
 
+  virtual const char * const GetName() const { return "unknown"; };
   virtual Vector *GetCenter() const { return NULL; };
   virtual TesselPoint *GetPoint() const { return NULL; };
@@ -177,6 +182,6 @@
   virtual void GoToFirst() const {};
   virtual void GoToLast() const {};
-  virtual bool IsEmpty() const { return false; };
-  virtual bool IsEnd() const { return false; };
+  virtual bool IsEmpty() const { return true; };
+  virtual bool IsEnd() const { return true; };
 };
 
@@ -185,12 +190,17 @@
 class CandidateForTesselation {
   public :
+  CandidateForTesselation(BoundaryLineSet* currentBaseLine);
   CandidateForTesselation(TesselPoint* candidate, BoundaryLineSet* currentBaseLine, Vector OptCandidateCenter, Vector OtherOptCandidateCenter);
   ~CandidateForTesselation();
 
-  TesselPoint *point;
+  TesselPointList pointlist;
   BoundaryLineSet *BaseLine;
   Vector OptCenter;
   Vector OtherOptCenter;
-};
+  double ShortestAngle;
+  double OtherShortestAngle;
+};
+
+ostream & operator <<(ostream &ost, const  CandidateForTesselation &a);
 
 // =========================================================== class TESSELATION ===========================================
@@ -205,8 +215,10 @@
 
     void AddTesselationPoint(TesselPoint* Candidate, const int n);
+    void SetTesselationPoint(TesselPoint* Candidate, const int n) const;
     void AddTesselationLine(class BoundaryPointSet *a, class BoundaryPointSet *b, const int n);
     void AlwaysAddTesselationTriangleLine(class BoundaryPointSet *a, class BoundaryPointSet *b, const int n);
     void AddTesselationTriangle();
     void AddTesselationTriangle(const int nr);
+    void AddCandidateTriangle(CandidateForTesselation CandidateLine);
     void RemoveTesselationTriangle(class BoundaryTriangleSet *triangle);
     void RemoveTesselationLine(class BoundaryLineSet *line);
@@ -217,7 +229,7 @@
     void FindStartingTriangle(const double RADIUS, const LinkedCell *LC);
     void FindSecondPointForTesselation(class TesselPoint* a, Vector Oben, class TesselPoint*& OptCandidate, double Storage[3], double RADIUS, const LinkedCell *LC);
-    void FindThirdPointForTesselation(Vector NormalVector, Vector SearchDirection, Vector OldSphereCenter, class BoundaryLineSet *BaseLine, class TesselPoint *ThirdNode, CandidateList* &candidates, double *ShortestAngle, const double RADIUS, const LinkedCell *LC);
-    bool FindNextSuitableTriangle(BoundaryLineSet &Line, BoundaryTriangleSet &T, const double& RADIUS, const LinkedCell *LC);
-    int CheckPresenceOfTriangle(class TesselPoint *Candidates[3]);
+    void FindThirdPointForTesselation(Vector &NormalVector, Vector &SearchDirection, Vector &OldSphereCenter, CandidateForTesselation &CandidateLine, const class TesselPoint  * const ThirdNode, const double RADIUS, const LinkedCell *LC) const;
+    bool FindNextSuitableTriangle(CandidateForTesselation &CandidateLine, BoundaryTriangleSet &T, const double& RADIUS, const LinkedCell *LC);
+    int CheckPresenceOfTriangle(class TesselPoint *Candidates[3]) const;
     class BoundaryTriangleSet * GetPresentTriangle(TesselPoint *Candidates[3]);
 
@@ -239,5 +251,5 @@
     list<list<TesselPoint*> *> * GetPathsOfConnectedPoints(const TesselPoint* const Point) const;
     list<list<TesselPoint*> *> * GetClosedPathsOfConnectedPoints(const TesselPoint* const Point) const;
-    list<TesselPoint*> * GetCircleOfConnectedPoints(const TesselPoint* const Point, const Vector * const Reference = NULL) const;
+    list<TesselPoint*> * GetCircleOfSetOfPoints(set<TesselPoint*> *SetOfNeighbours, const TesselPoint* const Point, const Vector * const Reference = NULL) const;
     class BoundaryPointSet *GetCommonEndpoint(const BoundaryLineSet * line1, const BoundaryLineSet * line2) const;
     list<BoundaryTriangleSet*> *FindTriangles(const TesselPoint* const Points[3]) const;
@@ -258,4 +270,5 @@
     PointMap PointsOnBoundary;
     LineMap LinesOnBoundary;
+    CandidateMap OpenLines;
     TriangleMap TrianglesOnBoundary;
     int PointsOnBoundaryCount;
@@ -281,7 +294,9 @@
 
   private:
-    class BoundaryPointSet *TPS[3]; //this is a Storage for pointers to triangle points, this and BPS[2] needed due to AddLine restrictions
+    mutable class BoundaryPointSet *TPS[3]; //this is a Storage for pointers to triangle points, this and BPS[2] needed due to AddLine restrictions
 
     mutable PointMap::const_iterator InternalPointer;
+
+    //bool HasOtherBaselineBetterCandidate(const BoundaryLineSet * const BaseRay, const TesselPoint * const OptCandidate, double ShortestAngle, double RADIUS, const LinkedCell * const LC) const;
 };
 
